unit hauptu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,math,ExtCtrls, StdCtrls, ComCtrls,XPMan,jpeg,inifiles,MMSystem,
  DGLOpenGL,
  DanGeoU,SoundsU;

const
  _cap='OGL_ISS V1.0 2008 by Daniel Schwamm';
  _inifn='ogl_iss.ini';

  //earth----------------------------------------
  _earth_r      =6368000;
  _earth_y      =-_earth_r-345000;
  _earth_drot   =360/(90*60*10); //one rotation in 90 min

  //home parameter
  _home_pos_z=200;
  _iss_len=94;

  //space dimension--------------
  _space_r      =2*_earth_r;

  //speed factors-------------------
  _pstep=0.6; //flight speed adder
  _rstep=0.6; //rotation speed adder

  _pspeed_max=30;
  _rspeed_max=10;


  //depth buffer
  _NearClipping=1;
  _FarClipping=-1;

  //game
  _game_level_train   =1;
  _game_level_rookie  =2;
  _game_level_advanced=3;
  _game_level_profi   =4;
  _game_level_mad     =5;

  //number of same-time shots-----------
  _shot_c=50;

  //meteor----------------
  _meteor_max=50;
  _meteor_r=20;
  _meteor_state_none   =0;
  _meteor_state_fly    =1;
  _meteor_state_explode=2;
  _meteor_alarm=100;

  //path-------------------
  _path_c=2000;


type
  //meteor record-----------
  pmeteor=^tmeteor;
  Tmeteor=record
    posv:tv;
    radius,speed:single;
    state:byte;
    count:integer;
  end;

  //shot-record--------------
  pshot=^tshot;
  Tshot=record
    posv,poslastv,dirv:tv;
    count:integer;
  end;

  Thauptf = class(TForm)
    frequencyt: TTimer;
    footp: TPanel;
    cockpitp: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    XPManifest1: TXPManifest;
    backp: TPanel;
    viewp: TPanel;
    pxp: TPanel;
    pyp: TPanel;
    pzp: TPanel;
    rotxp: TPanel;
    rotyp: TPanel;
    rotzp: TPanel;
    meteorp: TPanel;
    detect_issp: TPanel;
    meteortxtp: TPanel;
    footimg: TImage;
    meteorcp: TPanel;
    Label4: TLabel;
    game_pointsp: TPanel;
    gameoverp: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    game_pointsl: TLabel;
    Label8: TLabel;
    game_hsl: TLabel;
    game_levell: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    gameoverimg: TImage;
    gamestartp: TPanel;
    gamestartimg: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    meteorimg: TImage;
    meteorexpimg: TImage;
    earthimg: TImage;
    spaceimg: TImage;
    isssmallimg: TImage;
    issbigimg: TImage;
    issbigsailimg: TImage;
    isssmallsailimg: TImage;
    Label16: TLabel;
    Label23: TLabel;
    Label28: TLabel;
    Label31: TLabel;
    Label7: TLabel;
    Label32: TLabel;
    game_statusp: TPanel;
    Label33: TLabel;
    Label34: TLabel;
    detect_mep: TPanel;
    Label35: TLabel;
    Label36: TLabel;
    frequencytb: TTrackBar;
    Label37: TLabel;
    Label38: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure frequencytTimer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure viewpResize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure frequencytbChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    homedir:string;

    //opengl environment
    handle_dc:HDC;
    handle_rc:HGLRC;

    //my position and axis-angeles
    posv,dposv:tv;
    rotv:tv;

    //speed values: fly and axis-rotation
    pspeed,rx_speed,ry_speed,rz_speed:single;

    //some flags & counters
    draw_visor_ok:bool;
    draw_path_ok:bool;
    flyhome_c:integer;

    //game parameters-----------
    game_iss_meteor,
    game_meteor_dim,
    game_points,
    game_hs_rookie,
    game_hs_advanced,
    game_hs_profi,
    game_hs_mad:integer;
    game_level,
    game_meteor_c:byte;
    game_meteor_speed:single;
    game_status:string;

    //sounds
    sound_shot:TMemoryStream;
    sound_explode:TMemoryStream;
    sound_alarm:TMemoryStream;
    sound_c:integer;
    sound_ok:bool;


    //time-counters-----------
    frequ_low,frequ_fast:single;

    //key holder----------------
    akey:word;
    actrl:bool;

    //grapcic-mode
    graphic_mode:byte;
    graphic_txok,
    graphic_earthok,
    graphic_spaceok:bool;

    //space----------------
    space_quad:PGLUquadric;
    space_tx:gluint;

    //earth----------------
    earth_quad:PGLUquadric;
    earth_tx:gluint;
    earth_rot:single;

    //iss---------------------
    iss_quad:PGLUquadric;
    iss_startv,iss_endv:tv;
    iss_big_tx:gluint;
    iss_big_sail_tx:gluint;
    iss_small_tx:gluint;
    iss_small_sail_tx:gluint;
    iss_small_sail_rot:single;
    iss_big_sail_rot:single;

    //shot--------------------------------
    shot_a:array[0.._shot_c]of tshot;
    shot_quad:PGLUquadric;
    shot_tx:gluint;
    shot_c:integer;

    //meteor------------------------------
    meteor_a:array[0.._meteor_max-1]of tmeteor;
    meteor_imga:array[0.._meteor_max-1]of timage;
    meteor_quad:PGLUquadric;
    meteor_tx:gluint;
    meteor_explode_tx:gluint;

    //path----------------------------------
    path_a:array[0.._path_c]of tv;
    path_c:integer;

    //----------------------------------------
    procedure initobjects;
    procedure meteor_set(r:integer);

    procedure game_start(level:byte);
    procedure game_start_show;
    procedure game_over_show;

    procedure graphic_mode_bind(tx:gluint;r,g,b:single);
    procedure graphic_mode_off;
    procedure game_points_set;
    procedure flyhome;
    procedure dosound(ms:tmemorystream);

    procedure draw_space;
    procedure draw_earth;
    procedure draw_iss;
    procedure path;
    procedure draw_path;
    procedure draw_meteors;
    procedure shot;
    procedure draw_shots;
    procedure draw_visor;
    procedure draw_scene;

    //---------------------------------------------------------------
    function CreateTexture(Width,Height:Word;pData:Pointer):Integer;
    function img2tx(img:timage):TGLuint;
    function f2s_cut(d:single):string;
    function LineInSphere(v1,v2,spherev:tv;radius:single;crossok:bool):bool;
    function getlookv:tv;
  end;

var
  hauptf: Thauptf;

implementation


{$R *.dfm}

//------------------------------------------------------------
//PROCEDURES
//------------------------------------------------------------

//create form-------------------------------------------------------
procedure Thauptf.FormCreate(Sender: TObject);
var
  r:integer;
  p:tpanel;
  img:timage;
begin
  homedir:=extractfilepath(application.exename);
  caption:=_cap;
  randomize;
  frequ_low:=0;
  frequ_fast:=0;
  sound_c:=0;

  //preparing sounds-------------------
  sound_shot:=TMemoryStream.Create;
  sound_shot.writeBuffer(_sound_shot,sizeof(_sound_explode));
  sound_explode:=TMemoryStream.Create;
  sound_explode.writeBuffer(_sound_explode,sizeof(_sound_shot));
  sound_alarm:=TMemoryStream.Create;
  sound_alarm.writeBuffer(_sound_alarm,sizeof(_sound_alarm));

  //set panels all same style
  for r:=0 to componentcount-1 do begin
    if not(components[r] is tpanel)then continue;
    p:=tpanel(components[r]);
    p.parentbackground:=false;
    //p.BevelInner:=bvnone;
    p.BevelOuter:=bvnone;
    p.color:=clblack;
    p.font.color:=clyellow;
  end;

  //arrange components
  backp.align:=alclient;
  viewp.align:=alclient;
  footimg.align:=alclient;
  gamestartimg.Align:=alclient;
  gamestartimg.picture.assign(footimg.Picture);
  gamestartp.visible:=false;
  gameoverimg.Align:=alclient;
  gameoverimg.picture.assign(footimg.Picture);
  gameoverp.visible:=false;
  meteorimg.align:=alclient;

  //create meteor-counter-images
  for r:=0 to _meteor_max-1 do begin
    img:=timage.Create(meteorcp);
    //img.Proportional:=true;
    img.stretch:=true;
    img.Picture.assign(meteorimg.picture);
    img.align:=alleft;
    img.Width:=meteorcp.Width div _meteor_max;
    img.height:=meteorcp.Height;
    img.parent:=meteorcp;
    img.Visible:=true;
    meteor_imga[r]:=img;
  end;

  //intialize opengl
  handle_DC:=GetDC(viewp.Handle);
  if not InitOpenGL then Application.Terminate;
  handle_RC:=CreateRenderingContext(handle_DC,[opDoubleBuffered],24,32,0,0,0,0);
  ActivateRenderingContext(handle_DC,handle_RC);
  glenable(GL_DEPTH_TEST);

  //read ini parameters
  with tinifile.create(homedir+_inifn) do begin
    draw_visor_ok:=readbool('param','draw_visor_ok',true);
    draw_path_ok:=readbool('param','draw_path_ok',false);
    footp.visible:=readbool('param','draw_cockpit_ok',true);
    sound_ok:=readbool('param','sound_ok',true);
    graphic_mode:=readinteger('param','graphic_mode',7);
    game_hs_rookie:=readinteger('param','game_hs_rookie',0);
    game_hs_advanced:=readinteger('param','game_hs_advanced',0);
    game_hs_profi:=readinteger('param','game_hs_profi',0);
    game_hs_mad:=readinteger('param','game_hs_mad',0);
    frequencytb.position:=readinteger('param','frequencytb',frequencytb.position);
    free;
  end;

  //create objects
  initobjects;

  //start action
  self.WindowState:=wsmaximized;
  frequencyt.enabled:=true;
  game_start_show;
end;

//clear program-------------------------------------------------------
procedure Thauptf.FormDestroy(Sender: TObject);
var
  r:integer;
begin

  //write ini parameters
  deletefile(homedir+_inifn);
  with tinifile.create(homedir+_inifn) do begin
    writebool('param','draw_path_ok',draw_path_ok);
    writebool('param','draw_cockpit_ok',footp.visible);
    writebool('param','draw_visor_ok',draw_visor_ok);
    writebool('param','sound_ok',sound_ok);
    writeinteger('param','graphic_mode',graphic_mode);
    writeinteger('param','game_hs_rookie',game_hs_rookie);
    writeinteger('param','game_hs_advanced',game_hs_advanced);
    writeinteger('param','game_hs_profi',game_hs_profi);
    writeinteger('param','game_hs_mad',game_hs_mad);
    writeinteger('param','frequencytb',frequencytb.position);
    free;
  end;

  //free textures
  glDeleteTextures(1,@space_tx);
  glDeleteTextures(1,@earth_tx);
  glDeleteTextures(1,@iss_big_tx);
  glDeleteTextures(1,@iss_big_sail_tx);
  glDeleteTextures(1,@iss_small_tx);
  glDeleteTextures(1,@iss_small_sail_tx);
  glDeleteTextures(1,@meteor_tx);
  glDeleteTextures(1,@meteor_explode_tx);

  //free quads
  gluDeleteQuadric(earth_quad);
  gluDeleteQuadric(iss_quad);
  gluDeleteQuadric(space_quad);
  gluDeleteQuadric(meteor_quad);

  //free meteor-counter-images
  for r:=0 to _meteor_max-1 do meteor_imga[r].Free;

  //free opengl environment
  DeactivateRenderingContext;
  DestroyRenderingContext(handle_RC);
  ReleaseDC(viewp.Handle,handle_DC);

  //free sounds
  sound_alarm.Free;
  sound_shot.Free;
  sound_explode.free;
end;

//--------------------------------------------------
procedure Thauptf.FormKeyDown(
  Sender: TObject;
  var Key:Word;
  Shift:TShiftState
);
begin
  akey:=0;

  if flyhome_c>0 then exit;


  //shift & ctrl state
  actrl:=(ssctrl in shift);

  //flight key pressed?
  if
    (key=vk_up)or
    (key=vk_down)or
    (key=vk_left)or
    (key=vk_right)
  then begin
    akey:=key;
    exit;
  end;

  if gameoverp.Visible then begin
    if key=vk_return then game_start_show;
    exit;
  end;

  if gamestartp.Visible then begin
    if      key=ord('1')  then game_start(_game_level_train)
    else if key=ord('2')  then game_start(_game_level_rookie)
    else if key=ord('3')  then game_start(_game_level_advanced)
    else if key=ord('4')  then game_start(_game_level_profi)
    else if key=ord('5')  then game_start(_game_level_mad)
    else if key=vk_escape then begin
      close;
      exit;
    end;
  end;

  if key=ord('G') then begin
    graphic_mode:=graphic_mode+1;
    if graphic_mode>7 then graphic_mode:=0;
  end
  else if key=ord('C')  then footp.Visible:=not footp.Visible
  else if key=ord('F')  then flyhome
  else if key=ord('P')  then draw_path_ok:=not draw_path_ok
  else if key=ord('S')  then sound_ok:=not sound_ok
  else if key=ord('V')  then draw_visor_ok:=not draw_visor_ok
  else if key=vk_space  then shot
  else if key=vk_escape then game_over_show;
end;

//set key holder back-----------------------------------------------------
procedure Thauptf.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  akey:=0;
  actrl:=false;
end;

//----------------------------------------------------------------
procedure Thauptf.viewpResize(Sender: TObject);
begin
  if not visible then exit;

  //center cockpit
  cockpitp.Left:=(footp.width-cockpitp.Width)div 2;
  cockpitp.top:=(footp.height-cockpitp.height)div 2;

  //center game start panel
  gamestartp.Left:=(viewp.width-gamestartp.Width)div 2;
  gamestartp.top:=(viewp.height-gamestartp.height)div 2;

  //center game over panel
  gameoverp.Left:=(viewp.width-gameoverp.Width)div 2;
  gameoverp.top:=(viewp.height-gameoverp.height)div 2;

  //ogl-adaptionen
  glViewport(0,0,viewp.ClientWidth,viewp.ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(
    50,
    viewp.ClientWidth/viewp.ClientHeight,
    _NearClipping,
    _FarClipping
  );
  glMatrixMode(GL_MODELVIEW);
  Draw_Scene;
end;

//-----------------------------------------------------
procedure thauptf.dosound(ms:tmemorystream);
var
  flags:cardinal;
begin
  if not sound_ok then begin
    sndPlaySound(nil,0);
    exit;
  end;

  if sound_c>0 then exit;
  if gameoverp.visible then exit;

  flags:=SND_MEMORY or SND_ASYNC;

  if ms=nil then begin
    sndPlaySound(nil,0);
    exit;
  end;

  sndPlaySound(ms.memory,flags);
  sound_c:=3;
end;

//initalize objects----------------------------------------------------
procedure thauptf.initobjects;
begin
  //space-----------------------------------------------
  space_quad:=gluNewQuadric;
  gluQuadricTexture(space_quad,TGLboolean(true));
  space_tx:=img2tx(spaceimg);

  //earth-----------------------------------------------
  earth_quad:=gluNewQuadric;
  gluQuadricTexture(earth_quad,TGLboolean(true));
  earth_tx:=img2tx(earthimg);

  //ISS-------------------------------------------------
  iss_quad:=gluNewQuadric;
  gluQuadricTexture(iss_quad,TGLboolean(true));
  iss_big_tx:=img2tx(issbigimg);
  iss_big_sail_tx:=img2tx(issbigsailimg);
  iss_small_tx:=img2tx(isssmallimg);
  iss_small_sail_tx:=img2tx(isssmallsailimg);
  iss_startv:=v_fill(0,0,-_iss_len/2);
  iss_endv:=v_fill(0,0,_iss_len/2);
  iss_small_sail_rot:=0;
  iss_big_sail_rot:=0;

  //meteors-----------------------------------------------
  meteor_quad:=gluNewQuadric;
  gluQuadricTexture(meteor_quad,TGLboolean(true));
  meteor_tx:=img2tx(meteorimg);
  meteor_explode_tx:=img2tx(meteorexpimg);
end;

//----------------------------------------------------------------------
{
         Z-Axis (+)
            |
            |
            |

   #########*##########   part_bigsolarsail
   #########*##########   part_bigsolarsail
         ---#             part_smallsolarsail
            *   +
       +++++*++++         part_center
            *   *
         ---#             part_smallsolarsail
   #########*##########   part_bigsolarsail
   #########*##########   part_bigsolarsail
 -----------+------------------------------------------ X-Axis (+)
         (0/0/0)
            |
            |
         Z-Axis (-)
}
//----------------------------------------------------------------------
procedure thauptf.draw_iss;
const
  _cylr=2.5;
  _cyls=20;

  _bigsailw  =4;_bigsailh  =70;
  _smallsailw=1;_smallsailh=20;

  //------------------------------------------
  {
               Y-Axis (+)
                 |
                 |
               #####
               #####
               #####
               #####
               ##### h
               #####
               #####
      -----------+--------------------- X-Axis (+)
                 |
                 w
  }
  //------------------------------------------
  procedure solarsail(width,height:single;tx:gluint);
  begin
    graphic_mode_bind(tx,1,1,1);
    glbegin(gl_quads);
      gltexcoord2f( 0,0);glvertex3f(0-(width/2),0+(height/2),0);
      gltexcoord2f( 0,1);glvertex3f(0+(width/2),0+(height/2),0);
      gltexcoord2f(10,1);glvertex3f(0+(width/2),0-(height/2),0);
      gltexcoord2f(10,0);glvertex3f(0-(width/2),0-(height/2),0);
    glend;
    graphic_mode_off
  end;

  //------------------------------------------
  {
                     A*
     E###############***#################B
                     ***
     D###############***#################C 4m
           70m       ***
                     5m
  }
  //------------------------------------------
  procedure part_bigsolarsail;
  begin
    glPushMatrix();

      //A) draw body-cylinder
      graphic_mode_bind(iss_big_tx,1,0.5,0.5);
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);
      graphic_mode_off;

      //positioning for solar sails
      glRotatef(90,1,0,0);                 //tilt back/forward
      glRotatef(90,0,0,1);                 //turn right
      glTranslatef(13-_bigsailw,0,0);      //shift forward
      glTranslatef(0,_bigsailh/2+_cylr,0); //shift right

      //B)big solar sail
      solarsail(_bigsailw,_bigsailh,iss_big_sail_tx);

      //C)big solar sail
      glTranslatef(-_bigsailw-1,0,0); //shift back
      solarsail(_bigsailw,_bigsailh,iss_big_sail_tx);

      //D)big solar sail
      glTranslatef(0,-_bigsailh-_cylr*2,0);    //shift left
      solarsail(_bigsailw,_bigsailh,iss_big_sail_tx);

      //E)big solar sail
      glTranslatef(_bigsailw+1,0,0); //shift forward
      solarsail(_bigsailw,_bigsailh,iss_big_sail_tx);

      //small solar sail under cylinder
      glTranslatef(0,_bigsailh/2+_cylr,0);    //shift right
      glTranslatef(-2.5,0,0);                 //shift back
      glTranslatef(0,0,_smallsailh/2/2+_cylr);  //shift down
      glRotatef(90,1,0,0);
      solarsail(_smallsailw,_smallsailh/2,iss_small_sail_tx);

    glPopMatrix();
  end;

  //------------------------------------------
  {

           Z-Axis (+)             Y-Axis (+)
              |                       |
             A**                   A*****
             ***           B#######******
    ABC######***           C#######******
        20m  ***           D#######******
             ***                   ******
              |                       |
     ---------+--------    -----------+----- X-Axis (+)

  }
  //------------------------------------------
  procedure part_smallsolarsail;
  begin
    glPushMatrix();

      //A)body cylinder
      graphic_mode_bind(iss_small_tx,1,1,1);
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);
      graphic_mode_off;

      //positioning for sails
      glRotatef(90,0,0,1);                    //turn right
      glTranslatef(0,0,13/2);                 //shift forward
      glTranslatef(0,-_smallsailh/2-_cylr,0); //shift left
      glTranslatef(1,0,0);                    //shift up

      //B)small solar sail
      solarsail(_smallsailw,_smallsailh,iss_small_sail_tx);

      //C)small solar sail
      glTranslatef(-_smallsailw-0.2,0,0); // shift down
      solarsail(_smallsailw,_smallsailh,iss_small_sail_tx);

      //D)small solar sail
      glTranslatef(-_smallsailw-0.2,0,0); // shift down
      solarsail(_smallsailw,_smallsailh,iss_small_sail_tx);

    glPopMatrix();
  end;

  //------------------------------------------
  {
             Z-Axis (+)                    Y-Axis (+)
               |                              |
              A**       B**                   |
              ***       ***            20m    |   13m
      D#######***C######***        ##########A**C#######B**
      ########***#######***        ##########***########***
       20m    ***  13m  ***          G**   F**
              ***       ***          ***   ***
               |                     ***E##***
               |                     ***###***
               |   T-Part             U-PART  |
     ----------+--------           -----------+----- X-Axis (+)
  }
  //------------------------------------------
  procedure part_center;
  begin
    glPushMatrix();
      graphic_mode_bind(iss_small_tx,0.5,0.5,0.5);
      
      //A)body cylinder
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      //t-part-------------------------------------------

      //B)parallel cylinder right
      glTranslatef(-13-_cylr,0,0); //shift right
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      //C)vertical connection
      glTranslatef(1,0,0);    //shift left
      glTranslatef(0,0,13/2); //shift forward
      glRotatef(90,0,1,0);    //rotate y-axis
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      //u-part-------------------------------------------

      //D)cylinder left
      glTranslatef(0,0,20-_cylr-1); //shift left
      glucylinder(iss_quad,_cylr,_cylr,20,_cyls,_cyls);

      //E)cylinder paralell under
      glTranslatef(0,-13,0);  //shift down
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      //F)horizontal right
      glRotatef(90,1,0,0);
      glTranslatef(0,0,-11);  //shift up
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      //G)parallel left
      glTranslatef(0,11,0);
      glucylinder(iss_quad,_cylr,_cylr,13,_cyls,_cyls);

      graphic_mode_off;
    glPopMatrix();
  end;

begin
  glPushMatrix();
    glTranslatef(iss_startv.x,iss_startv.y,iss_startv.z);

    //parts with big solar sail
    glRotatef(-iss_big_sail_rot*10,0,0,1);
    part_bigsolarsail;glTranslatef(0,0,13);
    glRotatef(-5,0,0,1);

    part_bigsolarsail;glTranslatef(0,0,13);
    glRotatef(+iss_big_sail_rot*10+5,0,0,1);

    //part width small solar sail
    glRotatef(iss_small_sail_rot,0,0,1);
    part_smallsolarsail;glTranslatef(0,0,13);
    glRotatef(-iss_small_sail_rot,0,0,1);

    //part in the middle width t- and u-part
    part_center;glTranslatef(0,0,13);

    //part width small solar sail
    glRotatef(iss_small_sail_rot,0,0,1);
    part_smallsolarsail;glTranslatef(0,0,13);
    glRotatef(-iss_small_sail_rot,0,0,1);

    //parts with big solar sail
    glRotatef(frequ_low*5,0,0,1);
    part_bigsolarsail;glTranslatef(0,0,13);
    glRotatef(5,0,0,1);
    part_bigsolarsail;glTranslatef(0,0,13);

  glPopMatrix();
end;

//visor-------------------------------------------------------
procedure thauptf.draw_visor;
var
  rd:integer;
begin
  glPushMatrix();
    gldisable(GL_DEPTH_TEST);
    glLoadIdentity;

    glTranslatef(0,0,-20);
    glLineWidth(2);
    rd:=3;

    //cross
    glLineWidth(1);
    glBegin(GL_LINES);
      glVertex3f(-rd,-rd,rd);glVertex3f(rd,rd,rd);
      glVertex3f(rd,-rd,rd);glVertex3f(-rd,rd,rd);
    glEnd();

    //frame
    glLineWidth(2);
    glBegin(GL_LINE_LOOP);
      glVertex3f( rd, rd, rd);
      glVertex3f(-rd, rd, rd);
      glVertex3f(-rd,-rd, rd);
      glVertex3f( rd,-rd, rd);
    glEnd();

    glLineWidth(1);
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//---------------------------------------------------------------------
procedure thauptf.meteor_set(r:integer);
var
  d:single;
  pm:pmeteor;
begin
  pm:=@meteor_a[r];

  //set meteors away from iss
  repeat
    pm.posv.x:=random(game_meteor_dim)-random(game_meteor_dim);
    pm.posv.y:=random(game_meteor_dim)-random(game_meteor_dim);
    pm.posv.z:=random(game_meteor_dim)-random(game_meteor_dim);
    d:=v_distance(iss_startv,pm.posv);
  until d>game_meteor_dim/2;

  pm.count:=0;
  pm.radius:=5+random(_meteor_r)/10;
  pm.state:=_meteor_state_fly;
  pm.speed:=0.05+random(trunc(game_meteor_speed*100))/100;
  meteor_imga[r].Visible:=true;
end;


//set new path-point----------------------------------------------------
procedure thauptf.path;
begin
  path_a[path_c]:=posv;
  inc(path_c);if path_c>_path_c-1 then path_c:=0;
end;

//draw the path in fast triangle mode------------------------------------
procedure thauptf.draw_path;
var
  r:integer;
begin
  glPushMatrix();
    for r:=0 to _path_c-1-1 do begin
      if(path_a[r].x=0)or(path_a[r+1].x=0) then continue;

      //change color
      if r mod 2=0 then glColor3f(1.0,0.5,0.5)
                   else glColor3f(0.5,1.0,0.5);

      glBegin(GL_TRIANGLE_STRIP);
        glVertex3f(path_a[r].x,path_a[r].y,path_a[r].z);
        glVertex3f(path_a[r].x+1,path_a[r].y+1,path_a[r].z+1);
        glVertex3f(path_a[r+1].x,path_a[r+1].y,path_a[r+1].z);
      glEnd();
    end;
    glColor3f(1.0,1.0,1.0);
  glPopMatrix();
end;

//generate a shot-circle----------------------------------------
procedure thauptf.shot;
const
  _max=10;
var
  v:tv;
  c,r:integer;
  deg:single;
  ps:pshot;
begin
  dosound(sound_shot);

  v:=getlookv;

  for c:=0 to _max-1 do begin

    //next free shot
    ps:=nil;
    for r:=0 to _shot_c-1 do begin
      if shot_a[r].count=0 then begin
        ps:=@shot_a[r];
        break;
      end;
    end;
    if ps=nil then break;


    //direction & start-position
    ps.dirv:=v;
    ps.posv:=posv;
    ps.count:=20;

    if c=0 then begin
      //after first shot adapt angle for circle
      v:=v_rot_y_deg(v,2);
      v:=v_rot_x_deg(v,2);
    end;

    //calculate angeles for circle
    deg:=(c+1)*360/_max;
    v:=v_rot_y_deg(v,sin(deg)*5);
    v:=v_rot_x_deg(v,cos(deg)*5);
  end;
  inc(shot_c);

  //every shot costs game_points
  game_points:=game_points-100;
  if game_points<0 then game_points:=0;
  game_points_set;
end;

//draw the shot-circle-------------------------------------------
procedure thauptf.draw_shots;
var
  r:integer;
  v:tv;
  ps:pshot;
begin
  graphic_mode_bind(meteor_tx,1,1,0.5);
  for r:=0 to _shot_c-1 do begin
    ps:=@shot_a[r];

    //shot on the qay?
    if ps.count=0 then continue;

    //save actual position
    v:=ps.posv;
    ps.poslastv:=v;

    //calculate new position
    v:=v_add(v,ps.dirv);
    ps.posv:=v;

    //speed up shot
    ps.dirv:=v_scale(ps.dirv,1.5);

    //decrement activity-counter
    ps.count:=ps.count-1;

    //draw shot
    glTranslatef(v.x,v.y,v.z);
    gluSphere(meteor_quad,1,5,5);
    glTranslatef(-v.x,-v.y,-v.z);

  end;
  graphic_mode_off
end;

//--------------------------------------------------
procedure thauptf.game_points_set;
begin
  game_pointsp.caption:=inttostr(game_points);
end;

//------------------------------------------------------------------
procedure thauptf.draw_scene;
begin
  //get graphic mode
  graphic_txok   :=(graphic_mode and 4)>0;
  graphic_earthok:=(graphic_mode and 2)>0;
  graphic_spaceok:=(graphic_mode and 1)>0;

  if graphic_txok then glPolygonMode(GL_FRONT_AND_BACK,GL_FILL)
                  else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);


  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity;

  //rotation & positioning
  glRotatef(360-rotv.x,1.0,0,0);
  glRotatef(360-rotv.y,0,1.0,0);
  glRotatef(360-rotv.z,0,0,1.0);
  glTranslatef(-posv.x,-posv.y,-posv.z);

  if graphic_spaceok then draw_space;
  if graphic_earthok then draw_earth;

  //iss is gone away?
  if
    (game_iss_meteor<>-1)and
    (meteor_a[game_iss_meteor].state=_meteor_state_explode)and
    (meteor_a[game_iss_meteor].count<20)
  then begin
  end
  else draw_iss;

  //scene is active?
  if
    not gamestartp.visible and
    not gameoverp.Visible or
    (gameoverp.Visible and(game_iss_meteor<>0))
  then begin
    if game_level<>_game_level_train then draw_meteors;
    draw_shots;
  end;

  if draw_path_ok then draw_path;

  if draw_visor_ok then draw_visor;

  SwapBuffers(handle_DC);
end;

//----------------------------------------------------------------------
{                       (0/0/0)
                          ISS
                           |
                           |y
                           |
                     (0/-345 km/0)
                        #######
             #############################
     #############################################
  ###################################################
  ###################################################
####################(0/-6368-345/0)####################
  ###################################################
  ###################################################
    ##############################################
             #############################
                       ########

}
//----------------------------------------------------------------------
procedure thauptf.draw_earth;
const
  _scale=100; //needed because of depth buffer problems
begin
  glPushMatrix();
    //keep constant distance so you never reach surface
    //needed because of the scaled hight
    //which is much less then in reality
    glTranslatef(posv.x,posv.y+_earth_y/_scale,posv.z);

    graphic_mode_bind(earth_tx,0.5,0.5,1);
    glRotatef(140,1,0,0);
    glRotatef(85,0,1,0);
    glRotatef(earth_rot,1,0,0);
    gluSphere(earth_quad,_earth_r/_scale,50,50);

    graphic_mode_off;
  glPopMatrix();
end;

//--------------------------------------------------------
procedure thauptf.graphic_mode_bind(tx:gluint;r,g,b:single);
begin
  if not graphic_txok then begin
    glColor3f(r,g,b);
    exit;
  end;
  glenable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,tx);
end;

//--------------------------------------------------------
procedure thauptf.graphic_mode_off;
begin
  glColor3f(1,1,1);
  glDisable(GL_TEXTURE_2D);
end;

//space-------------------------------------------------
procedure thauptf.draw_space;
begin
  glPushMatrix();
    gldisable(GL_DEPTH_TEST);
    glTranslatef(0,0,0);

    glRotatef(90,1,0,0);
    graphic_mode_bind(space_tx,0.1,0.1,0.1);
    gluSphere(space_quad,_space_r,20,20);

    graphic_mode_off;
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//--------------------------------------------------
procedure thauptf.game_start_show;
var
  r:integer;
begin
  cockpitp.Color:=clblack;
  game_pointsp.caption:='';
  detect_issp.Caption:='';
  detect_mep.Caption:='';
  meteorp.color:=clblack;
  meteorcp.caption:='';

  gameoverp.visible:=false;
  gamestartp.visible:=true;
  game_points:=0;
  game_level:=_game_level_train;

  game_status:='Select Dirty Game Mode!';

  //clear shots-----------------------------------------------
  for r:=0 to _shot_c-1 do shot_a[r].dirv:=v_fill(0,0,0);
  shot_c:=0;

  //clear meteors-iamge----------------------------------------
  for r:=0 to _meteor_max-1 do meteor_imga[r].Visible:=false;

  //clear path-----------------------------------------------
  for r:=0 to _path_c-1 do path_a[r]:=v_fill(0,0,0);
  path_c:=0;

  //go home position
  posv:=v_fill(0,0,_home_pos_z);dposv:=v_fill(0,0,0);
  rotv:=v_fill(0,0,0);

  //no movement or key action
  akey:=0;
  actrl:=false;
  pspeed:=0;
  rx_speed:=0;
  ry_speed:=0;
  rz_speed:=0;
  game_iss_meteor:=-1;
end;

//--------------------------------------------------
procedure thauptf.game_over_show;
var
  hs:integer;
  s:string;
begin
  if game_level=_game_level_train then begin
    //no highscore needed
    game_start_show;
    exit;
  end;

  if game_iss_meteor<>-1 then game_status:='THE ISS IS GONE AWAY :-('
                         else game_status:='YOU LUCKY BASTARD WIN :-)';

  if game_level=_game_level_rookie then begin
    if game_points>game_hs_rookie then game_hs_rookie:=game_points;
    s:='Rookie';
    hs:=game_hs_rookie;
  end
  else if game_level=_game_level_advanced then begin
    if game_points>game_hs_advanced then game_hs_advanced:=game_points;
    s:='Advanced';
    hs:=game_hs_advanced;
  end
  else if game_level=_game_level_profi then begin
    if game_points>game_hs_profi then game_hs_profi:=game_points;
    s:='Profi';
    hs:=game_hs_profi;
  end
  else begin
    if game_points>game_hs_mad then game_hs_mad:=game_points;
    s:='Mad';
    hs:=game_hs_mad;
  end;

  game_pointsl.Caption:=inttostr(game_points);
  game_levell.caption:='LEVEL "'+s+'" HIGHSCORE';
  game_hsl.caption:=inttostr(hs);
  gameoverp.visible:=true;
end;

//--------------------------------------------------------
procedure thauptf.game_start(level:byte);
var
  r:integer;
begin

  //home position, no movement
  flyhome_c:=0;
  posv:=v_fill(0,0,_home_pos_z);dposv:=v_fill(0,0,0);
  rotv:=v_fill(0,0,0);
  rx_speed:=0;
  ry_speed:=0;
  rz_speed:=0;
  gamestartp.visible:=false;
  game_level:=level;
  game_iss_meteor:=-1;


  if game_level=_game_level_train then begin
    game_status:='TRAINING';
    game_meteor_c:=0;
  end
  else if game_level=_game_level_rookie then begin
    game_status:='ROOKIE (Highscore '+inttostr(game_hs_rookie)+')';
    game_meteor_c:=10;
    game_meteor_dim:=5000;
    game_meteor_speed:=0.5;
  end
  else if game_level=_game_level_advanced then begin
    game_status:='ADVANCED (Highscore '+inttostr(game_hs_advanced)+')';
    game_meteor_c:=20;
    game_meteor_dim:=2000;
    game_meteor_speed:=1;
  end
  else if game_level=_game_level_profi then begin
    game_status:='PROFI (Highscore '+inttostr(game_hs_profi)+')';
    game_meteor_c:=30;
    game_meteor_dim:=2000;
    game_meteor_speed:=2;
  end
  else begin
    game_status:='MAD (Highscore '+inttostr(game_hs_mad)+')';
    game_meteor_c:=_meteor_max;
    game_meteor_dim:=2000;
    game_meteor_speed:=3;
  end;

  //set/show active meteors
  for r:=0 to game_meteor_c-1 do begin
    meteor_imga[r].width:=round(meteorcp.Width/game_meteor_c);
    meteor_imga[r].Visible:=true;
    meteor_set(r);
  end;

end;

//-----------------------------------------------------------
procedure thauptf.flyhome;
begin
  flyhome_c:=100;

  //delta position
  pspeed:=1;
  dposv.x:=-(posv.x)/flyhome_c;
  dposv.y:=-(posv.y)/flyhome_c;
  dposv.z:=-(posv.z-_home_pos_z)/flyhome_c;

  //delta rotation
  rx_speed:=(rotv.x)/flyhome_c;
  ry_speed:=(rotv.y)/flyhome_c;
  rz_speed:=(rotv.z)/flyhome_c;
end;

//-----------------------------------------------------
procedure thauptf.draw_meteors;

  //-------------------------------------------
  procedure draw_meteor(r:integer);
  var
    pm:pmeteor;
  begin
    pm:=@meteor_a[r];

    glPushMatrix();
      glTranslatef(pm.posv.x,pm.posv.y,pm.posv.z);

      //exploding meteor?
      if pm.state=_meteor_state_explode then begin
        graphic_mode_bind(meteor_explode_tx,1,0.8,0.6);
        pm.radius:=pm.radius*1.3;
        pm.count:=pm.count-1;
        gluSphere(meteor_quad,pm.radius,10,10);
      end
      else begin
        graphic_mode_bind(meteor_tx,0.8,0.8,0.8);
        glRotatef(90+frequ_fast*4,1,1,0);
        gluSphere(meteor_quad,pm.radius,5,5);
      end;

      graphic_mode_off;
    glPopMatrix();

  end;

  //-------------------------------------------
  function gozero(r:integer):tv;
  var
    av,nv:tv;
  begin
    //get meteor position
    av:=meteor_a[r].posv;

    //norm direction
    nv:=v_norm(av);

    //adapt speed of change
    nv:=v_scale(nv,meteor_a[r].speed);

    //calculate new position
    av:=v_sub(av,nv);
    result:=av;
  end;

var
  r,rr:integer;
  diss1,diss2,dissmin,
  dme,dmemin,
  dshot:single;
  pm:pmeteor;
  ps:pshot;
  gameoverok:bool;
begin
  glPushMatrix();

    dissmin:=game_meteor_dim;
    dmemin:=game_meteor_dim;
    gameoverok:=true;

    //walk all meteors
    for r:=0 to game_meteor_c-1 do begin
      pm:=@meteor_a[r];
      if pm.state=_meteor_state_none then continue;

      //at least one active meteor: game is running
      gameoverok:=false;

      //meteor is destroyed?
      if(pm.state=_meteor_state_explode)and(pm.count=0) then begin

        //dirty meteor who destroyed the iss?
        if game_iss_meteor=r then begin
          draw_meteor(r);
          game_over_show;
          exit;
        end;

        //hide meteor
        meteor_imga[r].Visible:=false;
        pm.state:=_meteor_state_none;

        //more distance to iss gives more game_points
        dshot:=v_distance(iss_startv,pm.posv);
        game_points:=game_points+trunc(dshot)*10;
        game_points_set;
        continue;
      end;

      //let meteor fly to iss
      pm.posv:=gozero(r);

      //meteor is solid?
      if pm.state<>_meteor_state_explode then begin

        //mark nearest distance from iss
        diss1:=v_distance(iss_startv,pm.posv);
        if diss1>=pm.radius then diss1:=diss1-pm.radius;
        diss2:=v_distance(iss_endv,pm.posv);
        if diss2>=pm.radius then diss2:=diss2-pm.radius;

        if diss1<dissmin then dissmin:=diss1;
        if diss2<dissmin then dissmin:=diss2;

        //meteor hits iss?
        if LineInSphere(iss_startv,iss_endv,pm.posv,pm.radius,false)then begin
          cockpitp.Color:=clred;
          detect_issp.caption:=f2s_cut(0);
          if game_iss_meteor=-1 then begin
            game_iss_meteor:=r;
            flyhome;
            exit;
          end;
        end;
      end;

      //meteor is hitting by shot?
      for rr:=0 to _shot_c-1 do begin
        ps:=@shot_a[rr];if ps.count=0 then continue;
        if LineInSphere(ps.posv,ps.poslastv,pm.posv,pm.radius,false)then begin
          //yes, change state to explode
          pm.state:=_meteor_state_explode;
          pm.count:=10;
          dosound(sound_explode);
        end;
      end;

      //draw dirty meteor
      draw_meteor(r);

      //detect nearest meteor to me
      dme:=v_distance(posv,pm.posv);
      if dme>=pm.radius then dme:=dme-pm.radius;
      if dme<dmemin then dmemin:=dme;
    end;
  glPopMatrix();

  //iss meteor alarm?
  detect_issp.caption:=f2s_cut(dissmin);
  if dissmin<_meteor_alarm then begin
    meteorp.color:=clred;
    if game_iss_meteor=-1 then dosound(sound_alarm);
  end
  else begin
    meteorp.color:=clblack;
  end;

  //nearest meteor to me
  detect_mep.caption:=f2s_cut(dmemin);

  //all meteors destroyed?
  if gameoverok then game_over_show;
end;

//------------------------------------------------------------------
procedure Thauptf.frequencytTimer(Sender: TObject);

  function flight(vz:integer):tv;
  begin
    pspeed:=pspeed+vz*_pstep;
    if pspeed> _pspeed_max then pspeed:= _pspeed_max;
    if pspeed<-_pspeed_max then pspeed:=-_pspeed_max;
    result:=getlookv;
  end;

  procedure rotate_axis(vz:integer;var rspeed:single);
  begin
    rspeed:=rspeed+vz*_rstep;
    if rspeed> _rspeed_max then rspeed:= _rspeed_max;
    if rspeed<-_rspeed_max then rspeed:=-_rspeed_max;
  end;

  procedure slowspeed(var speed:single);
  begin
    if speed=0 then exit;
    if speed>0 then speed:=speed-0.2;
    if speed<0 then speed:=speed+0.2;
    if abs(speed)<0.2 then speed:=0;
  end;

begin
  activecontrol:=nil;
  frequ_fast:=deg_norm(frequ_fast+1);
  frequ_low:=deg_norm(frequ_low+0.1);

  //rotation earth
  earth_rot:=deg_norm(earth_rot+_earth_drot);

  //rotation small solar sail
  if trunc(frequ_low)mod 5=4 then
    iss_small_sail_rot:=deg_norm(iss_small_sail_rot+1);

  //rotation big solar sail
  if trunc(frequ_low)mod 8=7 then
    iss_big_sail_rot:=deg_norm(iss_big_sail_rot+random(2));


  //change position/direction?
  if akey<>0 then begin

    if actrl then begin
      //rotation x-axis
      if      akey=vk_up    then rotate_axis( 1,rx_speed)
      else if akey=vk_down  then rotate_axis(-1,rx_speed);

      //rotation z-axis
      if      akey=vk_left  then rotate_axis( 1,rz_speed)
      else if akey=vk_right then rotate_axis(-1,rz_speed);

    end

    //flying
    else if akey=vk_right then rotate_axis( 1,ry_speed)
    else if akey=vk_left  then rotate_axis(-1,ry_speed)

    else if akey=vk_up   then dposv:=flight( 1)
    else if akey=vk_down then dposv:=flight(-1);
  end;

  if pspeed<>0 then begin
    if dposv.x<>0 then posv.x:=posv.x+dposv.x*pspeed;
    if dposv.y<>0 then posv.y:=posv.y+dposv.y*pspeed;
    if dposv.z<>0 then posv.z:=posv.z+dposv.z*pspeed;
    if draw_path_ok then path;
  end
  else begin
    dposv:=v_fill(0,0,0);
  end;

  if rx_speed<>0 then rotv.x:=deg_norm(rotv.x-rx_speed);
  if ry_speed<>0 then rotv.y:=deg_norm(rotv.y-ry_speed);
  if rz_speed<>0 then rotv.z:=deg_norm(rotv.z-rz_speed);


  if flyhome_c<=0 then begin
    slowspeed(pspeed);
    slowspeed(rx_speed);
    slowspeed(ry_speed);
    slowspeed(rz_speed);
  end;

  //cockpit info
  if cockpitp.Visible then begin
    pxp.caption:=f2s_cut(posv.x);rotxp.caption:=f2s_cut(rotv.x)+'';
    pyp.caption:=f2s_cut(posv.y);rotyp.caption:=f2s_cut(rotv.y)+'';
    pzp.caption:=f2s_cut(posv.z);rotzp.caption:=f2s_cut(rotv.z)+'';

    if flyhome_c>0 then
      game_statusp.caption:='*** FLY HOME '+inttostr(flyhome_c)+' ***'
    else
      game_statusp.caption:=game_status;

    game_pointsp.caption:=inttostr(game_points);
  end;

  draw_scene;

  if flyhome_c>0 then begin
    dec(flyhome_c);
    if flyhome_c=0 then begin
      pspeed:=0;
      rx_speed:=0;ry_speed:=0;rz_speed:=0;

      //fly home because of iss destroying?
      if game_iss_meteor<>-1 then begin
        //let the dirty meteor explode
        meteor_a[game_iss_meteor].state:=_meteor_state_explode;
        meteor_a[game_iss_meteor].count:=30;
        dosound(sound_explode);
      end;
    end;
  end;

  dec(sound_c);if sound_c<0 then sound_c:=0;
end;

procedure Thauptf.frequencytbChange(Sender: TObject);
begin
  activecontrol:=nil;
  frequencyt.Interval:=frequencytb.Position;
  frequencytb.Hint:='Frequenz-Intervall: '+inttostr(frequencyt.Interval);
end;

//------------------------------------------------------------
//FUNCTIONS
//------------------------------------------------------------

//return textur-pointer from image-memory-datas --------------------
function thauptf.CreateTexture(Width,Height:Word;pData:Pointer):Integer;
var
  Texture:TGLuint;
begin
  glGenTextures(1,@Texture);
  glBindTexture(GL_TEXTURE_2D,Texture);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_LINEAR);

  gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB,Width,Height,GL_RGBA,GL_UNSIGNED_BYTE,pData);
  result:=Texture;
end;

//return textur-pointer from timage--------------------
function thauptf.img2tx(img:timage):TGLuint;
var
  data:Array of LongWord;
  w,x:integer;
  h,y:integer;
  bmp:tbitmap;
  c:longword;
  line:^longword;
begin
  bmp:=TBitmap.Create;
  bmp.Assign(img.Picture.Graphic);

  //ogl braucht 32bit-pics
  bmp.PixelFormat:=pf32bit;
  w:=bmp.width;
  h:=bmp.height;
  SetLength(data,w*h);

  for y:=0 to h-1 do begin
    line:=bmp.scanline[h-y-1];
    for x:=0 to w-1 do begin
      c:=line^ and $FFFFFF; // Need to do a color swap
      data[x+(y*w)]:=(((c and $FF)shl 16)+(c shr 16)+(c and $FF00)) or $FF000000;
      inc(line);
    end;
  end;

  BMP.free;
  result:=CreateTexture(w,h,addr(Data[0]));
end;

//float 2 short string---------------------
function thauptf.f2s_cut(d:single):string;
begin
  result:=format('%.2f',[d]);
end;

//give back rotated look vector about all axis-----------------------
function thauptf.getlookv;
var
  v:tv;
  mx,my,mz,m:tm;
begin
  //fill roation matrices
  mx:=m_fill_rot_x_deg(rotv.x);
  my:=m_fill_rot_y_deg(rotv.y);
  mz:=m_fill_rot_z_deg(rotv.z);

  //create "generl" rotation matrice
  m:=m_mul(mz,my);
  m:=m_mul(m,mx);

  //rotate the look vector about all axis
  v:=v_fill(0,0,-1);
  v:=m_v_mul(m,v);

  result:=v;
end;

// check if a line starts in sphere or cross the sphere.
// crossok is true: result only true if line cross the sphere completly
// http://www.koders.com/cpp/fidF5B34643282700B33C8E7A9A45877FD5F77D9FB8.aspx?s=cdef%3Atree
function thauptf.LineInSphere(v1,v2,spherev:tv;radius:single;crossok:bool):bool;
var
  dirv,diffv:tv;
  linelen,a,b,Discriminant,root,cross:single;
begin
  result:=false;

  // Lnge und normalisierte Richtung der Linie berechnen
  //Vector3D LineDir(LineB - LineA);
  //const float LineLength = LineDir.Length();
  //LineDir /= LineLength;

  //direction of line
  dirv:=v_sub(v2,v1);
  linelen:=v_len(dirv);

  //norm line direction
  dirv:=v_norm(dirv);

  // Die zwei Hilfsvariablen a und b berechnen
  //const Vector3D Diff(LineA - Sphere);
  diffv:=v_sub(v1,spherev);

  {
  const float a = 2.0f * (LineDir.x * Diff.x +
                          LineDir.y * Diff.y +
                          LineDir.z * Diff.z);
  }
  a:=2*(dirv.x*diffv.x+dirv.y*diffv.y+dirv.z*diffv.z);


  //const float b = Diff.LengthSq() - Radius * Radius;
  b:=v_len(diffv);
  b:=b*b-radius*radius;

  // Die Diskriminante berechnen (a/4 - b)
  //const float Discriminant = ((a * a) * 0.25f) - b;
  Discriminant:=((a*a)*0.25)-b;

  // Wenn die Diskriminante kleiner als null ist,
  // dann gibt es keine Schnittpunkte.
  if Discriminant<0 then exit;

  // Die Wurzel und danach die zweite Lsung der Gleichung berechnen
  //const float Root = sqrtf(Discriminant);
  root:=sqrt(Discriminant);

  //const float s = a * -0.5f - Root;
  cross:=-a/2-root;


  if cross>LineLen then exit;

  // Ist dieser Schnittpunkt in Ordnung?
  //nur true, wenn line ganz durchgeht
  //if(cross<0)or(cross>LineLen)then exit;
  //true
  if crossok and(cross<0)then exit;


  result:=true;
end;

procedure Thauptf.Button1Click(Sender: TObject);
var
  v,v2:tv;
begin
  v:=v_fill(0,0,-1);

  v:=v_rot_x_deg(v,90);
  v:=v_rot_y_deg(v,90);
  v:=v_rot_z_deg(v,90);

  v2:=v;

  //caption:=f2s_cut(v_angle_deg(v1,v2));
end;

end.

